/***************************************************************************

  CDatabase.h

  The Database class

  (c) 2000-2003 Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CDATABASE_H
#define __CDATABASE_H

#include "gambas.h"
#include "gb.db.h"

#ifndef __CDATABASE_C
extern GB_DESC CConnectionDesc[];
extern GB_DESC CDBDesc[];
extern GB_DESC CConnectionTablesDesc[];
extern GB_DESC CConnectionDatabaseDesc[];
extern GB_DESC CConnectionUserDesc[];
#else

#define THIS ((CDATABASE *)_object)

#endif

typedef
  struct {
    GB_BASE ob;
    DB_DRIVER *driver;
    DB_DATABASE handle;
    DB_DESC desc;
    char *charset;

    char **tables;
    GB_HASHTABLE dict;

    char **databases;
    char *database;

    char **users;
    char *user;
    DB_USER user_info;
    bool lower;
    }
  CDATABASE;


#endif
