/***************************************************************************

  CTable.h

  The Table class

  (c) 2000-2003 Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CTABLE_H
#define __CTABLE_H

#include "gambas.h"
#include "gb.db.h"
#include "CDatabase.h"

#ifndef __CTABLE_C
extern GB_DESC CTableDesc[];
extern GB_DESC CTableFieldDesc[];
extern GB_DESC CTableIndexDesc[];
#else

#define THIS ((CTABLE *)_object)

#endif

typedef
  struct {
    GB_BASE ob;
    DB_DRIVER *driver;
    CDATABASE *db;

    char *table;

    bool create;
    DB_FIELD *new_fields;
    char **primary;

    char **fields;
    char *field;
    DB_FIELD field_info;

    char **indexes;
    char *index;
    DB_INDEX index_info;
    }
  CTABLE;

#endif
